/***************************************************************************
 *   Copyright (C) 2011-2014 by Flukz Team                                 *
 *   Contact : see our web site http://flukz.org/                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef COMMIT_WIDGET_H
#define COMMIT_WIDGET_H

#include "../networkengine/message.h"

#include <QDialog>

class QLineEdit;
class QLabel;
class QPushButton;

class CommitWidget : public QDialog {
  Q_OBJECT
	
  public:
	explicit CommitWidget(QWidget* parent = 0);
	
	enum DialogPossibleKind {CommitDialog=0, RenameDialog=1, DeleteDialog=2, 
							 UploadDialog=3, RevertDialog=4};
	
	//TODO : public pointer
	QLineEdit *serverFileName;			//name on the server after the upload
	Message commitMessage;
	static QString lastUsedDirectory;
	
  public slots:
	void setDialogType(DialogPossibleKind dialogKindInit, bool userIsLoggedInit);
	void setTargetFile(const QString& targetFileName);
	
  signals:
	void askCommit(Message message);
	
  private:
	QLineEdit *localFileName;			//local path and name of the file to upload
	QPushButton *chooseFileButton;		//button to open a dialog and choose the file
	
	QLineEdit *comment;					//comment of the commit
	QLineEdit *author, *license, *sourceLink;

	QPushButton *confirmButton;
	QLabel *titleLabel1, *titleLabel2, *messageLabel, *messageLabelB,
		   *authorLabel, *licenseLabel, *sourceLabel, *explainLabel;
	
	bool waitingNetworkAnswer;
	bool sendingMetaData;
	
	DialogPossibleKind dialogKind;
	
	QString metaData();
	void sendMetaData();
	
  private slots:
	void chooseFile();
	void commitValidation();
	void networkMessage(Message message);		//receive replies from the network
};

#endif
