/***************************************************************************
 *   Copyright (C) 2011-2014 by Flukz Team                                 *
 *   Contact : see our web site http://flukz.org/                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef LOGIN_WIDGET_H
#define LOGIN_WIDGET_H

#include "../networkengine/message.h"

#include <QDialog>

class QLineEdit;
class QLabel;
class QPushButton;

class LoginWidget : public QDialog {
  Q_OBJECT
	
  public:
	explicit LoginWidget(QWidget* parent = 0);
	QLineEdit *userNameEdit, *passwordEdit;
	bool isAccountCreation;
	
  public slots:
	void promptUserName(const QString& userName);
	
  signals:
	void askCommit(Message message);
	
  private:
	QLineEdit *passwordConfirmEdit;
	
	QPushButton *confirmButton, *createButton;
	QLabel *titleLabel0, *titleLabel1, *titleLabel2, *titleLabel3, *messageLabel;
	QLabel *explainLabel0, *explainLabel1, *explainLabel2;
	
	bool userNameIsValid();
	bool passwordIsValid();
	bool passwordConfirmIsValid();
	
	bool waitingNetworkAnswer;	//used to lock the widget when waiting network answers
	
	Message commitMessage;
	
  private slots:
	void userNameValidation();
	void passwordValidation();
	void passwordConfirmValidation();
	void completeValidation();
	void createAccountDialog();
	void startUserCreation();
	void startUserAuthentication();
	void networkMessage(Message message);		//receive replies from the network
};

#endif
