/***************************************************************************
 *   Copyright (C) 2011-2014 by Flukz Team                                 *
 *   Contact : see our web site http://flukz.org/                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SERVER_OBJECT_H
#define SERVER_OBJECT_H

#include"connection.h"
#include <QObject>

class QTcpServer;

class ServerObject : public QObject {
	Q_OBJECT
  public:
	explicit ServerObject(bool isMasterInit, QObject *parent = 0);
	
  public slots:
	void launchServer();
	void activateCommandLineDisplay();
	
  signals:
	void statusChanged(const QString&);
	
  private:
	QTcpServer* server;
	static unsigned int connectionCount;
	static unsigned int serverStartTime;
	bool isMaster;
	
	QString statusPage();
	QString runSystemCommand(const QString& command);
	QString listFilesPage();
	
  private slots:
	void newConnection();		//called when a new connection enters the tcp server
	void endConnection();		//called when a connection is destroyed
	void processMessage(const Message& message, Connection* connection);
	void commandLineDisplay(const QString& status);
};

#endif
