/***************************************************************************
 *   Copyright (C) 2011-2014 by Flukz Team                                 *
 *   Contact : see our web site http://flukz.org/                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "serverwidget.h"
#include "serverobject.h"
#include "filerepository.h"

#include <QPushButton>
#include <QLabel>
#include <QHBoxLayout>
#include <QGridLayout>

ServerWidget::ServerWidget(bool isMasterInit, QWidget *parent) : QDialog(parent) {
	setWindowTitle(tr("Main Server"));
	
	//-------------------------- Interface-----------------------
	statusLabel = new QLabel;
	QPushButton * quitButton = new QPushButton(tr("Quit"));
	quitButton->setAutoDefault(false);
	connect(quitButton, SIGNAL(clicked()), this, SLOT(close()));
	
	QHBoxLayout *quitButtonLayout = new QHBoxLayout;
	quitButtonLayout->addStretch(1);
	quitButtonLayout->addWidget(quitButton);
	quitButtonLayout->addStretch(1);
	
	FileRepository::initRepo(/*isClientSide*/ false);
	
	QGridLayout *mainLayout = new QGridLayout;
	mainLayout->addWidget(statusLabel, 0, 0);
	mainLayout->addLayout(quitButtonLayout, 1, 0);
	setLayout(mainLayout);
	
	//Server Object
	ServerObject* serverObject = new ServerObject(isMasterInit, this);
	connect(serverObject, SIGNAL(statusChanged(const QString&)), statusLabel, SLOT(setText(const QString&)));
	serverObject->launchServer();
}
