/***************************************************************************
 *   Copyright (C) 2011-2014 by Flukz Team                                 *
 *   Contact : see our web site http://flukz.org/                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIFFTOOL_H
#define DIFFTOOL_H

#include <QString>

//the methods of this class are all static (DiffTool is just used as name prefix)
class DiffTool {
  public:
	//compute the differences between two strings
	//this function changes the string given in parameters
	static void diffHtml(QString& oldString, QString& newString);
	
  private:
	//internal functions to the diff tool
	static void formatToNoHtml(QString & wikiString);
	static void formatDiffHtml(QString & wikiString);
	
	static void longestCommonSubstring(QString &string1, QString &string2, int& indice1, int & indice2, int& commonlength);
	static bool split(QString& string1, QString& string2);
	static void findDiff(QString& string1, QString& string2);
	static void colorDiff(QString& string1);
};

#endif
