/***************************************************************************
 *   Copyright (C) 2011-2014 by Flukz Team                                 *
 *   Contact : see our web site http://flukz.org/                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef PARAMETERWIDGET_H
#define PARAMETERWIDGET_H

#include "../global.h"
#include "parameter.h"
#include <QWidget>

class QTableWidget;
class QTableWidgetItem;

class ParameterWidget : public QWidget {
  Q_OBJECT
	
  public:
	explicit ParameterWidget( QWidget* parent = 0);
	void setParameterList(QString title, QList<Parameter> parametersInit, std::string separatorIni);
	void setParametersValue(std::string s);
	
  signals:
	void contentChanged(std::string s);
	
  private:
	QTableWidget* tableWidget;
	bool signalItemChange;
	std::string stringSeparator;
	
	QList<Parameter> parameters;
	
	QPoint savedPos;
	QSize savedSize;
	bool savedPosExist;
	
	QString removeForbiddenCharacter(const QString &targetString);
	
  private slots:
	void itemHasChanged(QTableWidgetItem * senderItem);
	
  protected:
	void closeEvent(QCloseEvent *event);
};

#endif
